	subroutine flux(nmax,r,iper,capt,q,t,qt,al1,cks,
     $qa,slo,dusz,ths,thr,eps,j1,pi,nmx1,nmn,lcv,ncc,nv,
     &lwt,rt,nts,tx,dwt,qin)
	implicit none
	integer j1,nmax,nmx1,iper,i,i1,k,k1,nmn,ncc,nv,nts,tx
	real al,al1,cks,qa,slo,ths,thr
	real capt(*),q(*)
c ! 	real dusz(nts+1)
	double precision t,tf,q1a,q1b,q2a,q2b,qta,qtb,bot,qtop,pi
	double precision qt,q2old,delq2,tdif1,tdif2,tstar,smt
	double precision arg1,arg2,eps,dusz,qin
c ! 	double precision qt0a,qt0b,derfc
	double precision dwt,q0a,q0b
	double precision z,psih,qlb,ck,th,b1
c ! 	double precision d2a,d2b,dtop,dbot,dwta,dwtb,dwt,q0a,q0b
c ! 	double precision deld2,d2old
	double precision r(nmax),rt(nmax,nts+1)
	logical lcv,lwt
 	smt=0.05d0
	b1=cos(slo)
c ! coordinate transformation, added 8/4/2006, corrected 9/5/06	
	al=al1*b1*b1
c !	write(*,*) 'al1, al1*b1*b1',al1, al
	tf=al*cks/(ths-thr)
c ! 	write (*,*) tf, dusz(j1)
c ! 9 April 2004 added rt() to track roots as wt changes
	if (j1.eq.1 .or. lwt) then
c !	  call roots(nmax,r,dusz(j1),al,eps,pi)
	  call roots(nmax,r,dusz,al,eps,pi)
	  do 50, k=1,nmax
	    rt(k,j1)=r(k)
  50	  continue
	else
	  do 55, k=1,nmax
	    rt(k,j1)=rt(k,j1-1)
  55	  continue
	end if
	qt=0.0
	dwt=0.0
	qta=0.0
	qtb=0.0
	nmx1=0
	nmn=nmax+1
	qin=0.
	do 40 i=1,iper
c ! 	write(*,*) 'q(i),qa,al,dusz,slo',q(i),qa,al,dusz,slo
c ! i1 points to the earliest value of dusz and rt corresponding to
c ! each time step of surface infiltration,  MAY NEED TO MODIFY IF USING
c ! SIMPSON'S RULE FOR NUMERICAL INTEGRATION IN CALLING ROUTINE...
	  i1=1+(i-1)*tx
      	  tdif1=t-capt(i)
	  if(tdif1 .gt. 0.0) then
	    qin=q(i)
	    tstar=tf*tdif1
	    arg1=al*dusz/(2.*sqrt(tstar))
	    if(tstar .lt. smt) then
c ! Early-time solution ...............
		z=dusz
		qlb=cks
		call smallt(tstar,al,qa,q(i),dusz,
     &qlb,ths,thr,qta,psih,ck,th,z)  
	        nmn=1
	        write(*,*) 'using ETS for basal flux'
	    else    
c ! later-time solution ...............	    
   	      q2a=0.0
c ! 	      d2a=0.0
	      do 10 k=1,nmax
	        bot=1.+al*dusz/2.+2.*al*dusz*r(k)**2
 	        qtop=r(k)*sin(r(k)*al*dusz)*
     &           exp(-(r(k)**2)*tstar)
c !  	        dtop=rt(k,i1)*sin(rt(k,i1)*al*dusz(i1))*
c !      &           (1.0-exp(-(rt(k,i1)**2+1./4.)*tstar))
c !  	        dbot=(rt(k,i1)**2+1./4.)*bot*tf
c !	        write(*,*) 'bot, qtop', bot,qtop
c !	        write(*,*) 'dbot, dtop 1', dbot,dtop
     	        q2old=q2a
	        q2a=q2a+qtop/bot
c !  	        d2old=d2a
c !  	        d2a=d2a+dtop/dbot
	        delq2=abs((q2a-q2old)/q2a)
c !  	        deld2=abs((d2a-d2old)/d2a)
	        k1=k
c ! 	        if(delq2.lt.1.0e-04 .and. deld2.lt.1.0e-03) go to 11
	        if(delq2.lt.1.0e-06) go to 11
	        if(abs(q2a).lt.eps .and. k.gt.3) go to 11
   10         continue
              if(lcv) then
                ncc=ncc+1
                nv=1
                lcv=.false.
              end if
c !                 write(*,*) 'noncv Q a!', k1,t,tstar,tdif1
   11         continue
c !                 write(*,*) 'Q a!', k1,t,tstar,tdif1
 	      if(k1.gt.nmx1) nmx1=k1
	      if(k1.lt.nmn) nmn=k1
	      q0a=q(i)
	      q1a=4.d0*(q(i)-qa)*exp(al*dusz/2.)
!	      q0a=q(i)*cos(slo)
!	      q1a=4.d0*(q(i)-qa)*cos(slo)*exp(al*dusz/2.)
	      qta=q0a-q1a*q2a*exp(-tstar/4.)
c ! 	      dwta=q0a*tstar/tf-q1a*d2a
  	    end if
	  else 
	    qta=0.0
c ! 	    dwta=0.0
	  end if
c !       	  write(*,*) 'q0a,q1a,q2a,qta', q0a,q1a,q2a,qta
	  tdif2=t-capt(i+1)
	  if(tdif2 .gt. 0.0) then
	    tstar=tf*tdif2
	    arg2=al*dusz/(2.*sqrt(tstar))
	    if(tstar .lt. smt) then
c ! Early-time solution ...............	    
	      call smallt(tstar,al,qa,q(i),dusz,
     &qlb,ths,thr,qtb,psih,ck,th,z)  
	      nmn=1
	        write(*,*) 'using ETS for basal flux'
	    else
c ! later-time solution ...............	    
              q2b=0.0
c ! 	      d2b=0.0
	      do 20 k=1,nmax
                bot=1.+al*dusz/2.+2.*al*dusz*r(k)**2
	        qtop=r(k)*sin(r(k)*al*dusz)*
     &           exp(-(r(k)**2)*tstar)
c ! 	        dtop=rt(k,i1)*sin(rt(k,i1)*al*dusz(i1))*
c !      &           (1.0-exp(-(rt(k,i1)**2+1./4.)*tstar))
c ! 	        dbot=(rt(k,i1)**2+1./4.)*bot*tf
c !	        write(*,*) 'dbot, dtop 2', dbot,dtop
     	        q2old=q2b
	        q2b=q2b+qtop/bot
c ! 	        d2old=d2b
c ! 	        d2b=d2b+dtop/dbot
	        delq2=abs((q2b-q2old)/q2b)
c ! 	        deld2=abs((d2a-d2old)/d2a)
	        k1=k
c ! 	        if(delq2.lt.1.0e-04 .and. deld2.lt.1.0e-03) go to 21
	        if(delq2.lt.1.0e-06) go to 21
	        if(abs(q2b).lt.eps .and. k.gt.3) go to 21
   20	      continue
              if(lcv) then
                ncc=ncc+1
                nv=1
                lcv=.false.
              end if
c !                 write(*,*) 'noncv Q b!', k1,t,tstar,tdif2
   21	      continue
c !                 write(*,*) 'Q b!', k1,t,tstar,tdif2
	      if(k1.gt.nmx1) nmx1=k1
	      if(k1.lt.nmn) nmn=k1
	      q0b=q(i)
	      q1b=4.d0*(q(i)-qa)*exp(al*dusz/2.)
!	      q0b=q(i)*cos(slo)
!	      q1b=4.d0*(q(i)-qa)*cos(slo)*exp(al*dusz/2.)
	      qtb=q0b-q1b*q2b*exp(-tstar/4.)
c !  	      dwtb=q0b*tstar/tf-q1b*d2b
c ! 	      write(*,*) 'q0b,q1b,q2b,qtb',q0b,q1b,q2b,qtb
   	    end if
      	  else
            qtb=0.0
c ! 	    dwtb=0.0
      	  end if
      	    qt=qt+qta-qtb
c !     	    dwt=dwt+(dwta-dwtb)
c !   	write(*,*) 'dwt,dwta,dwtb',dwt,dwta,dwtb
c !    	write(*,*) 'qt,qta,qtb',qt,qta,qtb
   40 	continue
	return
	end

